Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs	(revision 51)
@@ -0,0 +1,1173 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmNewOrContinueCopy : Form
+    {
+        #region ログ使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示コントロール定義
+        /// </summary>
+        private enum Dispcount
+        {
+            ConstructionCode = 0,
+            ConstructionName,
+            SalesPerson,
+            ConstructionPerson,
+            ConstructionPeriod,
+            radioButton1,
+            ConstructionCode1,
+            radioButton2,
+            ConstructionCode2,
+            radioButton3,
+            ConstructionCode3,
+            radioButton4,
+            ConstructionCode4,
+        }
+        /// <summary>
+        /// 工事名称
+        /// </summary>
+        private const int s_ConstructionNameLength = 120;
+        /// <summary>
+        /// 見積提出期限（日）
+        /// </summary>
+        private static int s_EstimatesSubmitDeadline = 7;
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// 終了状態フラグ
+        /// </summary>
+        private DialogResult m_EndButton = DialogResult.None;
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        private int m_ConstructionCode = 0;
+        /// <summary>
+        /// コンロールオブジェクト
+        /// </summary>
+        private Control[] m_dispControl;
+        /// <summary>
+        /// 新規工事番号取得
+        /// </summary>
+        private bool m_NewConstruction = false;
+        #endregion
+
+        #region プロパティ
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        public int ConstructionCode
+        {
+            get { return m_ConstructionCode; }
+            set { m_ConstructionCode = value; }
+        }
+        /// <summary>
+        /// 新規工事番号取得
+        /// </summary>
+        public bool NewConstruction
+        {
+            get { return m_NewConstruction; }
+        }
+        /// <summary>
+        /// 終了ボタン状態
+        /// </summary>
+        public DialogResult EndButton
+        {
+            get { return m_EndButton; }
+        }
+        #endregion
+
+        #region フォームクローズ
+        private void FrmNewOrContinueCopy_FormClosed(object sender, FormClosedEventArgs e)
+        {
+            if (m_EndButton == DialogResult.None) m_EndButton = DialogResult.Cancel;
+
+        }
+        #endregion
+        
+        #region コンストラクタ
+        /// <summary>
+        /// フォーム初期化
+        /// </summary>
+        public FrmNewOrContinueCopy()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        
+        #region フォームロード
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmCostStructureDiag_Load(object sender, EventArgs e)
+        {
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+            // コントロールのセット
+            SetDisplayObject();
+
+            // 営業期セット
+            SetcmbConstructionPeriod();
+
+            // 担当者セット
+            SetcmbPersons();
+
+            // 初期表示
+            InitDataLoad();
+        }
+        #endregion
+        
+        #region キャンセルボタン
+        /// <summary>
+        /// キャンセルボタン追加
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnCancel_Click(object sender, EventArgs e)
+        {
+            m_EndButton = DialogResult.Cancel;
+            this.Close();
+        }
+        #endregion
+
+        #region 実行ボタン
+        /// <summary>
+        /// 実行ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnExecProc1_Click(object sender, EventArgs e)
+        {
+            // データ存在チェック
+            if (!DispFeildCheck()) return;
+
+            // データコピー
+            if (!CopyTableData())
+            {
+                MessageBox.Show("データコピーに失敗しました。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                return;
+            }
+
+            m_EndButton = DialogResult.Yes;
+            this.Close();
+        }
+        #endregion
+        
+        #region ラジオボタン
+        /// <summary>
+        /// チェックボタンの変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void radioButton1_CheckedChanged(object sender, EventArgs e)
+        {
+            if (radioButton1.Checked)
+            {
+                tableLayoutPanel3.Visible = true;
+                lblNextMessage.Visible = false;
+                // 工事番号の表示
+                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = true;
+                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
+            }
+            else if (radioButton2.Checked)
+            {
+                tableLayoutPanel3.Visible = false;
+                lblNextMessage.Visible = true;
+                // 工事番号の表示
+                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = true;
+                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
+            }
+            else if (radioButton3.Checked)
+            {
+                tableLayoutPanel3.Visible = false;
+                lblNextMessage.Visible = true;
+                // 工事番号の表示
+                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = true;
+                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
+            }
+            else if (radioButton4.Checked)
+            {
+                tableLayoutPanel3.Visible = false;
+                lblNextMessage.Visible = true;
+                // 工事番号の表示
+                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
+                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = true;
+            }
+            // 工事番号の表示
+            SetConstructionCode();
+        }
+
+        #endregion
+
+        #region 画面クリア
+        /// <summary>
+        /// 画面クリア
+        /// </summary>
+        private void ClearDisplay()
+        {
+            try
+            {
+                foreach (Control wrk in m_dispControl)
+                {
+                    if (CommonMotions.chkObjectIsNull(wrk)) continue;
+                    if (!wrk.GetType().Equals(typeof(CheckBox))) continue;
+                    wrk.Text = "";
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region オブジェクトコントロールセット
+        /// <summary>
+        /// 表示オブジェクトの取得
+        /// </summary>
+        private void SetDisplayObject()
+        {
+            int CtrlCnt = Enum.GetNames(typeof(Dispcount)).Length;
+            m_dispControl = new Control[CtrlCnt];
+
+            m_dispControl[(int)Dispcount.ConstructionCode] = label14;
+            m_dispControl[(int)Dispcount.ConstructionName] = label10;
+            m_dispControl[(int)Dispcount.SalesPerson] = label11;
+            m_dispControl[(int)Dispcount.ConstructionPerson] = label12;
+            m_dispControl[(int)Dispcount.ConstructionPeriod] = cmbConstructionPeriod;
+            m_dispControl[(int)Dispcount.radioButton1] = radioButton1;
+            m_dispControl[(int)Dispcount.radioButton2] = radioButton2;
+            m_dispControl[(int)Dispcount.radioButton3] = radioButton3;
+            m_dispControl[(int)Dispcount.radioButton4] = radioButton4;
+            m_dispControl[(int)Dispcount.ConstructionCode1] = label1;
+            m_dispControl[(int)Dispcount.ConstructionCode2] = label5;
+            m_dispControl[(int)Dispcount.ConstructionCode3] = label16;
+            m_dispControl[(int)Dispcount.ConstructionCode4] = label17;
+        }
+        #endregion
+
+        #region 初期関連
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            try
+            {
+                // クリア
+                ClearDisplay();
+
+                if (!DisplayData())
+                {
+                    m_EndButton = DialogResult.Cancel;
+                    this.Close();
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 担当者名取得
+        /// <summary>
+        /// 担当者名を取得する
+        /// </summary>
+        /// <param name="PersonCode"></param>
+        /// <returns></returns>
+        private string GetPersonName(int PersonCode)
+        {
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            try
+            {
+                string strRet = string.Empty;
+
+                string strPerson = picDB.CreatePrimarykeyString(PersonCode);
+                PersonInChargeMaster picRec = new PersonInChargeMaster();
+                if (picDB.SelectAction(strPerson, ref picRec)) strRet =picRec.PersonName;
+
+                return strRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+            finally
+            {
+                picDB.close(); picDB = null;
+            }
+
+        }
+        #endregion
+
+        #region データチェック
+        /// <summary>
+        /// データ表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            IOConstructionBaseInfo cbDB = new IOConstructionBaseInfo();
+            IOEstimateData edDB = new IOEstimateData();
+            try
+            {
+                bool bRet = true;
+                bool BaseFlg = true;
+                bool EstiFlg = true;
+
+                // 工事基本情報取得
+                string strSQL = cbDB.CreatePrimarykeyString(m_ConstructionCode);
+                ConstructionBaseInfo cbRec = new ConstructionBaseInfo();
+                if (!cbDB.SelectAction(strSQL, ref cbRec)) BaseFlg = false;
+
+                // 積算見積データ取得
+                strSQL = edDB.CreatePrimarykeyString(m_ConstructionCode);
+                EstimateData edRec = new EstimateData();
+                if (!edDB.SelectAction(strSQL, ref edRec)) EstiFlg = false;
+
+                if (radioButton1.Checked)
+                {   // 両方コピー
+                    if (BaseFlg && EstiFlg)
+                    {
+                        bRet = true;
+                    }
+                    else if (!BaseFlg)
+                    {
+                        MessageBox.Show("工事基本情報がありません。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bRet = false;
+                    }
+                    else if (!EstiFlg)
+                    {
+                        MessageBox.Show("積算見積データがありません。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bRet = false;
+                    }
+                    else
+                    {
+                        MessageBox.Show("工事基本情報・積算見積データがありません。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bRet = false;
+                    }
+                }
+                else if (radioButton2.Checked)
+                {   // 積算データコピー
+                    if (EstiFlg)
+                    {
+                        bRet = true;
+                    }
+                    else
+                    {
+                        MessageBox.Show("積算見積データがありません。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bRet = false;
+                    }
+                }
+                else if (radioButton3.Checked)
+                {   // 工事基本情報コピー
+                    if (BaseFlg)
+                    {
+                        bRet = true;
+                    }
+                    else
+                    {
+                        MessageBox.Show("工事基本情報がありません。", "コピーエラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bRet = false;
+                    }
+                }
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+                edDB.close(); edDB = null;
+            }
+        }
+        #endregion
+
+        #region データ表示
+        /// <summary>
+        /// データ表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DisplayData()
+        {
+            IOConstructionBaseInfo cbDB = new IOConstructionBaseInfo();
+            IOConstructionBaseInfoDetail cbdDB = new IOConstructionBaseInfoDetail();
+            IOEstimateData edDB = new IOEstimateData();
+            try
+            {
+                bool bRet = true;
+
+                // 元工事番号
+                m_dispControl[(int)Dispcount.ConstructionCode].Text = CommonMotions.cnvStringCodeFromInt(m_ConstructionCode, "-", 8);
+
+                // 工事基本情報取得
+                string strSQL = cbDB.CreatePrimarykeyString(m_ConstructionCode);
+                ConstructionBaseInfo cbRec = new ConstructionBaseInfo();
+                if (!cbDB.SelectAction(strSQL, ref cbRec)) return false;
+
+                // 積算見積データ取得（見積データが無くてもコピーを行う 2016/07/19）
+                //strSQL = edDB.CreatePrimarykeyString(m_ConstructionCode);
+                //EstimateData edRec = new EstimateData();
+                //if (!edDB.SelectAction(strSQL, ref edRec)) return false;
+
+                // 工事名称取得
+                strSQL = cbdDB.CreatePrimarykeyString(m_ConstructionCode, (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                ConstructionBaseInfoDetail cbdRec = new ConstructionBaseInfoDetail();
+                if (!cbdDB.SelectAction(strSQL, ref cbdRec)) return false;
+                m_dispControl[(int)Dispcount.ConstructionName].Text = cbdRec.DetailString;
+                toolTip1.SetToolTip(m_dispControl[(int)Dispcount.ConstructionName], cbdRec.DetailString);
+
+                // 担当者表示
+                m_dispControl[(int)Dispcount.SalesPerson].Text = GetPersonName(cbRec.SalesPersonCode);
+                toolTip1.SetToolTip(m_dispControl[(int)Dispcount.SalesPerson], m_dispControl[(int)Dispcount.SalesPerson].Text);
+                cmbSalesPerson.SelectedValue = cbRec.SalesPersonCode;
+
+                m_dispControl[(int)Dispcount.ConstructionPerson].Text = GetPersonName(cbRec.ConstructionPersonCode);
+                toolTip1.SetToolTip(m_dispControl[(int)Dispcount.ConstructionPerson], m_dispControl[(int)Dispcount.ConstructionPerson].Text);
+                cmbConstructionPerson.SelectedValue = cbRec.ConstructionPersonCode;
+
+                // 工事番号表示
+                SetConstructionCode();
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+                cbdDB.close(); cbdDB = null;
+                edDB.close(); edDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事情報・見積データコピー時の工事番号表示(radiobutton1)
+        /// <summary>
+        /// 工事情報・見積データコピー時の工事番号表示(radiobutton1)
+        /// </summary>
+        /// <param name="cbDB"></param>
+        private bool DispChildDataCode(IOConstructionBaseInfo cbDB)
+        {
+            try
+            {
+                int ConstructionCode = 0;
+
+                // 工事枝番のカウントアップ分工事番号取得
+                ConstructionCode = cbDB.CreateNextBranchCounstructionCode(m_ConstructionCode);
+
+                // 工事番号表示
+                m_dispControl[(int)Dispcount.ConstructionCode1].Text = CommonMotions.cnvStringCodeFromInt(ConstructionCode, "-", 8);
+
+                // 作成限界を超えた場合はエラーにする
+                if (ConstructionCode < 0)
+                {
+                    MessageBox.Show("新規工事番号が取得できません。", "継続作成エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+                else if ((ConstructionCode - m_ConstructionCode) > 99)
+                {
+                    MessageBox.Show("変更作成の上限数を超えました、\nこれ以上は作成できません、\n新規工事として作成してください。",
+                                    "継続作成エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+                
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 工事番号表示
+        /// <summary>
+        /// 工事番号の表示
+        /// </summary>
+        private void SetConstructionCode()
+        {
+            IOConstructionBaseInfo cbDB = new IOConstructionBaseInfo();
+            try
+            {
+                btnExecProc1.Enabled = true;
+
+                // 工事番号クリア
+                m_dispControl[(int)Dispcount.ConstructionCode1].Text = string.Empty;
+                m_dispControl[(int)Dispcount.ConstructionCode2].Text = string.Empty;
+                m_dispControl[(int)Dispcount.ConstructionCode3].Text = string.Empty;
+                m_dispControl[(int)Dispcount.ConstructionCode4].Text = string.Empty;
+
+                // ----- 工事情報・見積データコピー
+                if (radioButton1.Checked)
+                {
+                    // ----- 継続工事番号の表示
+                    if (!DispChildDataCode(cbDB)) btnExecProc1.Enabled = false;
+
+                    // ----- ここで抜ける（以下の処理は新規工事番号取得）
+                    return;
+                }
+
+                // 現在データを取得する
+                string strExistsData = cbDB.CreatePrimarykeyString(m_ConstructionCode);
+                ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
+                if (!cbDB.SelectAction(strExistsData, ref BaseRec)) return;
+
+                // ----- 見積データのみコピー・工事情報のみコピー
+                int PeriodValue = 0;
+                if (CommonMotions.SystemMasterData.ConstructionNoBase == (int)CommonDefine.SystemConstructionNoBase.BusinessPeriod)
+                    PeriodValue = BaseRec.ConstructionPeriod;
+                else
+                    PeriodValue = BaseRec.ConstructionYear;
+
+                // 新規工事番号の表示
+                int ConstructionCode = cbDB.CreateNewCounstructionCode(PeriodValue);
+                // 作成限界を超えた場合はエラーにする
+                if (ConstructionCode < 0)
+                {
+                    MessageBox.Show("新規工事番号が取得できません。", "継続作成エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                if (radioButton2.Checked)
+                    m_dispControl[(int)Dispcount.ConstructionCode2].Text = CommonMotions.cnvStringCodeFromInt(ConstructionCode, "-", 8);
+                else if (radioButton3.Checked)
+                    m_dispControl[(int)Dispcount.ConstructionCode3].Text = CommonMotions.cnvStringCodeFromInt(ConstructionCode, "-", 8);
+                else if (radioButton4.Checked)
+                    m_dispControl[(int)Dispcount.ConstructionCode4].Text = CommonMotions.cnvStringCodeFromInt(ConstructionCode, "-", 8);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                cbDB.close(); cbDB = null;
+            }
+        }
+
+        #endregion
+
+        #region 営業期コンボボックス
+        /// <summary>
+        /// 営業期コンボボックスへ文字をセットする
+        /// </summary>
+        private bool SetcmbConstructionPeriod()
+        {
+            try
+            {
+                cmbConstructionPeriod.Items.Clear();
+                cmbConstructionPeriod.Text = "";
+
+                if (CommonMotions.SystemMasterData.ConstructionNoBase == (int)CommonDefine.SystemConstructionNoBase.BusinessPeriod)
+                {
+                    // 期数セット（-2年～+2年）
+                    int NowPeriod = CommonMotions.SystemMasterData.BusinessPeriod;
+                    if (NowPeriod > 2) cmbConstructionPeriod.Items.Add((NowPeriod - 2).ToString());
+                    if (NowPeriod > 1) cmbConstructionPeriod.Items.Add((NowPeriod - 1).ToString());
+                    cmbConstructionPeriod.Items.Add(NowPeriod.ToString());
+                    cmbConstructionPeriod.Items.Add((NowPeriod + 1).ToString());
+                    cmbConstructionPeriod.Items.Add((NowPeriod + 2).ToString());
+
+                    // 今季セット
+                    if (cmbConstructionPeriod.Items.Count == 5)
+                        cmbConstructionPeriod.SelectedIndex = 2;
+                    else if (cmbConstructionPeriod.Items.Count == 4)
+                        cmbConstructionPeriod.SelectedIndex = 1;
+                    else if (cmbConstructionPeriod.Items.Count == 3)
+                        cmbConstructionPeriod.SelectedIndex = 0;
+                }
+                else
+                {
+                    label7.Text = "営業年度";
+                    int NowYear = CommonMotions.SystemMasterData.ConstructionYear;
+
+                    cmbConstructionPeriod.Items.Add((NowYear - 2).ToString());
+                    cmbConstructionPeriod.Items.Add((NowYear - 1).ToString());
+                    cmbConstructionPeriod.Items.Add((NowYear).ToString());
+                    cmbConstructionPeriod.Items.Add((NowYear + 1).ToString());
+                    cmbConstructionPeriod.Items.Add((NowYear + 2).ToString());
+
+                    // 今季セット
+                    cmbConstructionPeriod.SelectedIndex = 2;
+
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 担当者コンボボックス
+        /// <summary>
+        /// 担当者コンボボックスへ文字をセットする
+        /// </summary>
+        private bool SetcmbPersons()
+        {
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            List<PersonInChargeMaster> workList = new List<PersonInChargeMaster>(); ;
+            try
+            {
+                cmbSalesPerson.DataSource = null;
+                cmbSalesPerson.Items.Clear();
+                cmbSalesPerson.Text = "";
+
+                // 担当者マスタを検索する
+                string strSQL = " Where DeleteFlg = 0 Order By EmployeeClassFlg ASC, DisplayOrder ASC";
+
+                // 担当者マスタ読込
+                if (!picDB.SelectAction(strSQL, ref workList)) return false;
+
+                List<KeyValuePair<int, string>> SalesDataList = new List<KeyValuePair<int, string>>();
+                List<KeyValuePair<int, string>> ConstructionDataList = new List<KeyValuePair<int, string>>();
+                SalesDataList.Add(new KeyValuePair<int, string>(0, ""));
+                ConstructionDataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (PersonInChargeMaster work in workList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(work.PersonCode, work.PersonName);
+
+                    SalesDataList.Add(keyval);
+                    ConstructionDataList.Add(keyval);
+                }
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbSalesPerson, SalesDataList);
+                ComboBoxAction.InitDataSetCombBox(cmbConstructionPerson, ConstructionDataList);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                picDB.close();
+                picDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事情報・積算見積コピー
+        /// <summary>
+        /// 工事基本情報・積算見積のコピー
+        /// </summary>
+        /// <returns></returns>
+        private bool CopyTableData()
+        {
+            IOConstructionBaseInfo DB1 = new IOConstructionBaseInfo();                  // 工事基本情報
+            IOConstructionBaseInfoDetail DB2 = new IOConstructionBaseInfoDetail();      // 工事基本情報明細
+            IOEstimateData DB3 = new IOEstimateData();                                  // 積算見積データ  
+            IOEstimateDataBody DB4 = new IOEstimateDataBody();                          // 積算見積ボディ
+            IOEstimateDataDetail DB5 = new IOEstimateDataDetail();                      // 積算見積明細
+            IOConstructionProgressDate DB6 = new IOConstructionProgressDate();          // 案件進捗日付データ
+            try
+            {
+                int iToCode = 0;
+
+                // コピー先工事番号取得
+                if (radioButton1.Checked)
+                    iToCode = CommonMotions.cnvIntFromStringCode(m_dispControl[(int)Dispcount.ConstructionCode1].Text, "-");
+                else if (radioButton2.Checked)
+                    iToCode = CommonMotions.cnvIntFromStringCode(m_dispControl[(int)Dispcount.ConstructionCode2].Text, "-");
+                else if (radioButton3.Checked)
+                    iToCode = CommonMotions.cnvIntFromStringCode(m_dispControl[(int)Dispcount.ConstructionCode3].Text, "-");
+                else if (radioButton4.Checked)
+                    iToCode = CommonMotions.cnvIntFromStringCode(m_dispControl[(int)Dispcount.ConstructionCode4].Text, "-");
+
+                if (iToCode == 0)
+                {
+                    MessageBox.Show("新規工事番号が取得できません。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                // コピー処理
+                DB1.connect(); DB1.beginTran();
+                DB2.connect(); DB2.beginTran();
+                DB3.connect(); DB3.beginTran();
+                DB4.connect(); DB4.beginTran();
+                DB5.connect(); DB5.beginTran();
+                DB6.connect(); DB6.beginTran();
+
+                // デフォルトは新規工事にしておく
+                m_NewConstruction = true;
+
+                // ----- 工事基本情報・積算見積データコピー(枝番カウントアップ)
+                if (radioButton1.Checked)
+                {
+                    // 積算見積情報コピー
+                    if (!RecordCopyTypeB(m_ConstructionCode, iToCode, DB3, DB4, DB5))
+                    {
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+
+                    if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その２工事基本情報データ作成
+                    if (!InitSetBaseInfo(iToCode, DB1))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その３工事基本情報明細データ作成
+                    if (!InitSetBaseInfoDetail(m_ConstructionCode, iToCode, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+
+                    // 継続案件の場合は新規工事フラグを落とす
+                    m_NewConstruction = false;
+                }
+                // ----- 積算見積データコピー
+                else if (radioButton2.Checked)
+                {
+                    // 積算見積情報コピー
+                    if (!RecordCopyTypeB(m_ConstructionCode, iToCode, DB3, DB4, DB5))
+                    {
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+
+                }
+                // ----- 工事基本情報コピー
+                else if (radioButton3.Checked)
+                {
+                    if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その２工事基本情報データ作成
+                    if (!InitSetBaseInfo(iToCode, DB1))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その３工事基本情報明細データ作成
+                    if (!InitSetBaseInfoDetail(m_ConstructionCode, iToCode, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                }
+                // ----- 工事基本情報・積算見積データコピー(新規工事)
+                else if (radioButton4.Checked)
+                {
+                    // 積算見積情報コピー
+                    if (!RecordCopyTypeB(m_ConstructionCode, iToCode, DB3, DB4, DB5))
+                    {
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+
+                    if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その２工事基本情報データ作成
+                    if (!InitSetBaseInfo(iToCode, DB1))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                    // その３工事基本情報明細データ作成
+                    if (!InitSetBaseInfoDetail(m_ConstructionCode, iToCode, DB2))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        return false;
+                    }
+                }
+
+                // 案件進捗日付データ登録
+                if (!ProgressDate(DB6, iToCode))
+                {
+                    DB1.rollback();
+                    DB2.rollback();
+                    DB3.rollback();
+                    DB4.rollback();
+                    DB5.rollback();
+                    DB6.rollback();
+                    return false;
+                }
+
+                // 新規工事番号セット
+                m_ConstructionCode = iToCode;
+
+                DB1.commit();
+                DB2.commit();
+                DB3.commit();
+                DB4.commit();
+                DB5.commit();
+                DB6.commit();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DB1.close(); DB1 = null;
+                DB2.close(); DB2 = null;
+                DB3.close(); DB3 = null;
+                DB4.close(); DB4 = null;
+                DB5.close(); DB5 = null;
+                DB6.close(); DB6 = null;
+            }
+        }
+        #endregion
+
+        #region その２工事基本情報データ作成
+        /// <summary>
+        /// 工事基本情報設定
+        /// </summary>
+        /// <param name="cbRec"></param>
+        private bool InitSetBaseInfo(int ToCode, IOConstructionBaseInfo cbDB)
+        {
+            try
+            {
+                // 工事基本情報の設定
+                string strSQL = cbDB.CreatePrimarykeyString(ToCode);
+                ConstructionBaseInfo cbRec = new ConstructionBaseInfo();
+                if (!cbDB.SelectAction(strSQL, ref cbRec, false)) return false;
+
+                // 営業期・工事年度を更新する
+                int iPeriod = 0;
+                if (tableLayoutPanel3.Visible)
+                {
+                    iPeriod = CommonMotions.cnvInt(cmbConstructionPeriod.Text);
+                    if (CommonMotions.SystemMasterData.ConstructionNoBase == (int)CommonDefine.SystemConstructionNoBase.BusinessPeriod)
+                        cbRec.ConstructionPeriod = iPeriod;                                                 // 工事期
+                    else
+                        cbRec.ConstructionYear = iPeriod;	                                                // 工事年度
+                }
+
+                cbRec.ConstructionStatusFlg = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("依頼受け中")).Key;  // 工事進捗状態
+                cbRec.RequestedDate	= DateTime.Now;                                                 // 依頼受け日
+                cbRec.EstimatesSubmitDeadline = DateTime.Now.AddDays(s_EstimatesSubmitDeadline);	// 見積提出期限
+                cbRec.EstimatesSubmittedDate = DateTime.MinValue;	                                // 見積提出日
+                cbRec.EstimatesExpirationDate = DateTime.MinValue;	                                // 見積有効期限
+                cbRec.ProvisionalOrderDate = DateTime.MinValue;                                     // 仮受注日
+                cbRec.OrderDate = DateTime.MinValue;                                                // 受注日
+                cbRec.TransferConstructionDate = DateTime.MinValue;                                 // 部署引継日
+                cbRec.ConstructionStartingDate = DateTime.MinValue;                                 // 施工開始日
+                cbRec.ConstructionCompletionDate = DateTime.MinValue;                               // 施工完了日
+                cbRec.BillingStartDate = DateTime.MinValue;	                                        // 請求準備開始日
+                cbRec.BillingDate = DateTime.MinValue;	                                            // 請求日
+
+                // 工事情報のみコピー・新規工事作成は工事の情報以外はクリアする
+                if (radioButton3.Checked || radioButton4.Checked)
+                {
+                    cbRec.TyingFlg = (int)CommonDefine.BaseInfoTyingFlg.Standard;                   // 紐付データフラグ
+                    cbRec.OrderStartingDate = DateTime.MinValue;	                                // 開始予定日
+                    cbRec.OrderCompletionDate = DateTime.MinValue;	                                // 完了予定日
+                    cbRec.PreparationStartDate = DateTime.MinValue;                                 // 施工準備開始日
+                    cbRec.NonOrderDate = DateTime.MinValue;                                         // 非受注日
+                    cbRec.OrdersDecisionPrice = 0;                                                  // 税抜受注決定金額
+                    cbRec.OrdersDecisionPriceInTax = 0;                                             // 税込受注決定金額
+                    cbRec.ConstructionPersonCode = 0;                                               // 工事担当者コード
+                    cbRec.ConstrSubPersonCode = 0;	                                                // 工事副担当者コード
+                    cbRec.ConstructionInstructor = 0;                                               // 工事指導員コード
+                    cbRec.TransferConstruction = 0;                                                 // 移管先コード
+                    cbRec.TransferConstructionDate = DateTime.MinValue;                             // 工事移管日
+                    cbRec.ConstructionPeriodStart = DateTime.MinValue;                              // 契約工期開始
+                    cbRec.ConstructionPeriodEnd = DateTime.MinValue;                                // 契約工期完了
+                    cbRec.ConstructionPeriodStart2 = DateTime.MinValue;                             // 契約工期開始（延長時）
+                    cbRec.ConstructionPeriodEnd2 = DateTime.MinValue;                               // 契約工期完了（延長時）
+                    cbRec.StartDate = DateTime.MinValue;	                                        // 工事開始日
+                    cbRec.EndDate = DateTime.MinValue;                                              // 工事終了日
+                    cbRec.PurchaseOrderMailingDate = DateTime.MinValue;                             // 注文書郵送日
+                    cbRec.PurchaseOrderReturnDate = DateTime.MinValue;                              // 注文書返送日
+                    cbRec.PurchaseOrderReturnCheckDate = DateTime.MinValue;                         // 注文書返送確認日
+                    cbRec.ConsumptionTaxFlg = 1;                                                    // 消費税フラグ
+                    //cbRec.PrimeContractorFlg = 1;	                                                // 元請フラグ
+                    //cbRec.SalesCostFlg = 1;	                                                    // 営業経費発生フラグ
+                    //cbRec.EstimateType = 1;                                                       // 見積種別
+                    cbRec.BillingSplitFlg = 1;                                                      // 請求回数フラグ
+                    cbRec.BillingSendDate = DateTime.MinValue;                                      // 請求書郵送/手渡し日
+                }
+                else if (radioButton1.Checked)
+                {
+                    // 選択データが通常以外（増減工事の場合は紐付きフラグを子データにする）
+                    if (cbRec.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard)
+                    {
+                        cbRec.TyingFlg = (int)CommonDefine.BaseInfoTyingFlg.Tying;
+                    }
+                }
+
+                // 営業担当
+                if (cmbSalesPerson.Text.Length != 0)
+                {
+                    cbRec.SalesPersonCode = CommonMotions.cnvInt(cmbSalesPerson.SelectedValue.ToString());
+                }
+                // 工事担当
+                if (cmbConstructionPerson.Text.Length != 0)
+                {
+                    cbRec.ConstructionPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue.ToString());
+                }
+
+                // 更新処理
+                if (!cbDB.UpdateAction(strSQL, cbRec, false)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region その３工事基本情報明細データ作成
+        /// <summary>
+        /// 工事基本情報設定
+        /// </summary>
+        /// <param name="cbRec"></param>
+        private bool InitSetBaseInfoDetail(int FromCode, int ToCode, IOConstructionBaseInfoDetail cbidDB)
+        {
+            try
+            {
+                // 工事基本情報明細の設定
+                string strSQL = cbidDB.CreatePrimarykeyString(ToCode, (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                ConstructionBaseInfoDetail cbidRec = new ConstructionBaseInfoDetail();
+                if (!cbidDB.SelectAction(strSQL, ref cbidRec, false)) return false;
+
+                // 工事名を更新する
+                if (cbidRec.DetailString.Length < s_ConstructionNameLength - 2)
+                {
+                    // コピー元がコピーデータの場合に最後が数字かをチェック
+                    int CodeLowerwork = (FromCode % 100);
+                    if (CodeLowerwork != 1)
+                    {
+                        int subcnt = 1;
+                        if (CodeLowerwork > 9) subcnt = 2;
+                        string strwrok = cbidRec.DetailString.Substring(cbidRec.DetailString.Length - subcnt);
+                        // 最後が数字の場合はそれを除く
+                        if (CommonMotions.chkNumeric(strwrok))
+                        {
+                            cbidRec.DetailString = cbidRec.DetailString.Substring(0, cbidRec.DetailString.Length - subcnt);
+                        }
+                    }
+
+                    int CodeLower = (ToCode % 100);
+                    cbidRec.DetailString = cbidRec.DetailString + CodeLower.ToString();
+                }
+
+                // 更新処理
+                if (!cbidDB.UpdateAction(strSQL, cbidRec, false)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 工事基本情報一括レコードコピー処理（コピータイプＡ）
+        /// <summary>
+        /// 工事基本情報レコードコピー処理（コピータイプＡ）
+        /// </summary>
+        /// <param name="FromCode"></param>
+        /// <param name="ToCode"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool RecordCopyTypeA(int FromCode, int ToCode, IOConstructionBaseInfo DB1, IOConstructionBaseInfoDetail DB2)
+        {
+            try
+            {
+                // まず削除
+                string strSQL = DB1.CreatePrimarykeyString(ToCode);
+                DB1.DeleteAction(strSQL, false);
+                DB2.DeleteAction(strSQL, false);
+
+                if (!DB1.RecordCopyAction(FromCode, ToCode, false)) return false;
+                if (!DB2.RecordCopyAction(FromCode, ToCode, false)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(2), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 積算見積情報一括レコードコピー処理（コピータイプＢ）
+        /// <summary>
+        /// 積算見積情報レコードコピー処理（コピータイプＢ
+        /// ）
+        /// </summary>
+        /// <param name="FromCode"></param>
+        /// <param name="ToCode"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool RecordCopyTypeB(int FromCode, int ToCode, IOEstimateData DB1, IOEstimateDataBody DB2, IOEstimateDataDetail DB3)
+        {
+            try
+            {
+                // まず削除
+                string strSQL = DB1.CreatePrimarykeyString(ToCode);
+                DB1.DeleteAction(strSQL, false);
+                DB2.DeleteAction(strSQL, false);
+                DB3.DeleteAction(strSQL, false);
+
+                if (!DB1.RecordCopyAction(FromCode, ToCode, false)) return false;
+                if (!DB2.RecordCopyAction(FromCode, ToCode, false)) return false;
+                if (!DB3.RecordCopyAction(FromCode, ToCode, false)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(2), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 案件進捗日付データ登録
+        /// <summary>
+        /// 案件進捗日付データ登録
+        /// </summary>
+        /// <param name="cpdDB"></param>
+        /// <returns></returns>
+        public bool ProgressDate(IOConstructionProgressDate cpdDB, int ConstructionCode)
+        {
+            try
+            {
+                // まず削除
+                string strWhere = cpdDB.CreatePrimarykeyString(ConstructionCode);
+                cpdDB.DeleteAction(strWhere, false);
+
+                // データセット
+                ConstructionProgressDate Rec = new ConstructionProgressDate();
+                Rec.ConstructionCode = ConstructionCode;
+                Rec.ConstructionStatusFlg = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("依頼受け中")).Key; ;
+                Rec.PreviousStatusFlg = 0;
+                Rec.ChangeDate = DateTime.Now;
+                Rec.ChangePersonCode = CommonMotions.LoginUserData.PersonCode;
+
+                // 検索文字列作成
+                strWhere = cpdDB.CreatePrimarykeyString(Rec.ConstructionCode, Rec.ConstructionStatusFlg);
+
+                List<ConstructionProgressDate> workList = new List<ConstructionProgressDate>();
+                // データ登録
+                if (!cpdDB.InsertAction(Rec, false))
+                {
+                    MessageBox.Show("案件進捗日付データ：追加登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+    }
+}
